:- import slash/1 from machine.
:- import load_sgml_structure/3,
	  load_xml_structure/3,
	  load_structure/4 from sgml.

:- 
	sgmldir(SgmlDir),
	slash(Slash),
	writeln('***** Output redirected to .ok files in the actualoutput directory'),
	writeln('***** Compare it with .ok files in the expectedoutput directory'),
	writeln('***** Note: w3.ok will be slightly different, as this page changes constantly'),
	(
	  path_sysop( isdir, 'actualoutput') ->true
	; path_sysop( mkdir, 'actualoutput')
	),
	fmt_write_string(TestPath, '%s', f(SgmlDir)),
	fmt_write_string(TestFile1, '%s%samp.sgml',f(TestPath,Slash)),
	fmt_write_string(OutFile1, 'actualoutput%samp.ok', f(Slash)),
	tell(OutFile1),
	load_sgml_structure(file(TestFile1),O1, W1),
	writeln(O1),
	told,
	fmt_write_string(OutFile2, 'actualoutput%satt.ok', f(Slash)),
	tell(OutFile2),
	fmt_write_string(TestFile2, '%s%satt.xml',f(TestPath,Slash)),
	load_xml_structure(file(TestFile2),O2, W2),
	writeln(O2),
	told,
	fmt_write_string(OutFile3, 'actualoutput%sbar.ok', f(Slash)),
	tell(OutFile3),
        fmt_write_string(TestFile3, '%s%sbar.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile3),O3, W3),
        writeln(O3),
	told,
	fmt_write_string(OutFile4, 'actualoutput%sbat.ok', f(Slash)),
	tell(OutFile4),
	%% from here on it does not run on Win64
        fmt_write_string(TestFile4, '%s%sbat.sgml',f(TestPath,Slash)),
	catch( load_sgml_structure(file(TestFile4),O4, W4),
	       error(E),error_handler( error(E))), 
	told,
	fmt_write_string(OutFile5, 'actualoutput%scdata.ok', f(Slash)),
	tell(OutFile5),
        fmt_write_string(TestFile5, '%s%scdata.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile5),O5, W5),
        writeln(O5),
	told,
	fmt_write_string(OutFile6, 'actualoutput%scent-utf8.ok', f(Slash)),
	tell(OutFile6),
        fmt_write_string(TestFile6, '%s%scent-utf8.xml',f(TestPath,Slash)),
        load_xml_structure(file(TestFile6),O6, W6),
        writeln(O6),
	told,
	fmt_write_string(OutFile7, 'actualoutput%sce.ok', f(Slash)),
	tell(OutFile7),
	fmt_write_string(TestFile7, '%s%sce.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile7),O7, W7),
        writeln(O7),
	told,
	fmt_write_string(OutFile8, 'actualoutput%scmt.ok', f(Slash)),
	tell(OutFile8),
	fmt_write_string(TestFile8, '%s%scmt.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile8),O8, W8),
        writeln(O8),
	told,
	fmt_write_string(OutFile9, 'actualoutput%sconref2.ok', f(Slash)),
	tell(OutFile9),
	fmt_write_string(TestFile9, '%s%sconref2.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile9),O9, W9),
        writeln(O9),
	told,
	fmt_write_string(OutFile10, 'actualoutput%sconref.ok', f(Slash)),
	tell(OutFile10),
	fmt_write_string(TestFile10, '%s%sconref.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile10),O10, W10),
        writeln(O10),
	told,
	fmt_write_string(OutFile11, 'actualoutput%scrlf.ok', f(Slash)),
	tell(OutFile11),
	fmt_write_string(TestFile11, '%s%scrlf.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile11),O11, W11),
        writeln(O11),
	told,
	fmt_write_string(OutFile12, 'actualoutput%sdefent.ok', f(Slash)),
	tell(OutFile12),
	fmt_write_string(TestFile12, '%s%sdefent.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile12),O12, W12),
        writeln(O12),
	told,
	fmt_write_string(OutFile13, 'actualoutput%sentent.ok', f(Slash)),
	tell(OutFile13),
	fmt_write_string(TestFile13, '%s%sentent.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile13),O13, W13),
        writeln(O13),
	told,
	fmt_write_string(OutFile14, 'actualoutput%sestag.ok', f(Slash)),
	tell(OutFile14),
	fmt_write_string(TestFile14, '%s%sestag.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile14),O14, W14),
        writeln(O14),
	told,
	fmt_write_string(OutFile15, 'actualoutput%sfoo.ok', f(Slash)),
	tell(OutFile15),
	fmt_write_string(TestFile15, '%s%sfoo.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile15),O15, W15),
        writeln(O15),
	told,
	fmt_write_string(OutFile16, 'actualoutput%si.ok', f(Slash)),
	tell(OutFile16),
	fmt_write_string(TestFile16, '%s%si.sgml',f(TestPath,Slash)),
	load_sgml_structure(file(TestFile16), O16, W16),
        writeln(O16),
	told,
	fmt_write_string(OutFile17, 'actualoutput%smapbug.ok', f(Slash)),
	tell(OutFile17),
	fmt_write_string(TestFile17, '%s%smapbug.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile17),O17, W17),
        writeln(O17),
	told,
	fmt_write_string(OutFile18, 'actualoutput%sment.ok', f(Slash)),
	tell(OutFile18),
	fmt_write_string(TestFile18, '%s%sment.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile18),O18, W18),
        writeln(O18),
	told,
	fmt_write_string(OutFile19, 'actualoutput%sminus2.ok', f(Slash)),
	tell(OutFile19),
	fmt_write_string(TestFile19, '%s%sminus2.xml',f(TestPath,Slash)),
        load_xml_structure(file(TestFile19),O19, W19),
        writeln(O19),
	told,
	fmt_write_string(OutFile20, 'actualoutput%snetc.ok', f(Slash)),
	tell(OutFile20),
	fmt_write_string(TestFile20, '%s%snetc.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile20),O20, W20),
        writeln(O20),
	told,
	fmt_write_string(OutFile21, 'actualoutput%sng.ok', f(Slash)),
	tell(OutFile21),
	fmt_write_string(TestFile21, '%s%sng.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile21),O21, W21),
        writeln(O21),
	told,
	fmt_write_string(OutFile22, 'actualoutput%snoent.ok', f(Slash)),
	tell(OutFile22),
	fmt_write_string(TestFile22, '%s%snoent.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile22),O22, W22),
        writeln(O22),
	told,
	fmt_write_string(OutFile23, 'actualoutput%snot.ok', f(Slash)),
	tell(OutFile23),
	fmt_write_string(TestFile23, '%s%snot.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile23),O23, W23),
        writeln(O23),
	told,
	fmt_write_string(OutFile24, 'actualoutput%soma.ok', f(Slash)),
	tell(OutFile24),
	fmt_write_string(TestFile24, '%s%soma.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile24),O24, W24),
        writeln(O24),
	told,
	fmt_write_string(OutFile25, 'actualoutput%somit1.ok', f(Slash)),
	tell(OutFile25),
	fmt_write_string(TestFile25, '%s%somit1.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile25),O25, W25),
        writeln(O25),
	told,
	fmt_write_string(OutFile26, 'actualoutput%sper.ok', f(Slash)),
	tell(OutFile26),
	fmt_write_string(TestFile26, '%s%sper.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile26),O26, W26),
        writeln(O26),
	told,
	fmt_write_string(OutFile27, 'actualoutput%srcdata.ok', f(Slash)),
	tell(OutFile27),
	fmt_write_string(TestFile27, '%s%srcdata.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile27),O27, W27),
        writeln(O27),
	told,
	fmt_write_string(OutFile28, 'actualoutput%srdefent.ok', f(Slash)),
	tell(OutFile28),
	fmt_write_string(TestFile28, '%s%srdefent.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile28),O28, W28),
        writeln(O28),
	told,
	fmt_write_string(OutFile29, 'actualoutput%srsre.ok', f(Slash)),
	tell(OutFile29),
	fmt_write_string(TestFile29, '%s%srsre.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile29),O29, W29),
        writeln(O29),
	told,
	fmt_write_string(OutFile30, 'actualoutput%ssdata.ok', f(Slash)),
	tell(OutFile30),
	fmt_write_string(TestFile30, '%s%ssdata.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile30),O30, W30),
        writeln(O30),
	told,
	fmt_write_string(OutFile31, 'actualoutput%sshortval.ok', f(Slash)),
	tell(OutFile31),
	fmt_write_string(TestFile31, '%s%sshortval.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile31),O31, W31),
        writeln(O31),
	told,
	fmt_write_string(OutFile32, 'actualoutput%ssr2.ok', f(Slash)),
	tell(OutFile32),
	fmt_write_string(TestFile32, '%s%ssr2.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile32),O32, W32),
        writeln(O32),
	told,
	fmt_write_string(OutFile33, 'actualoutput%ssr.ok', f(Slash)),
	tell(OutFile33),
	fmt_write_string(TestFile33, '%s%ssr.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile33),O33, W33),
        writeln(O33),
	told,
	fmt_write_string(OutFile34, 'actualoutput%sugh.ok', f(Slash)),
	tell(OutFile34),
	fmt_write_string(TestFile34, '%s%sugh.sgml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile34),O34, W34),
        writeln(O34),
	told,
	fmt_write_string(OutFile35, 'actualoutput%sutf8-cent.ok', f(Slash)),
	tell(OutFile35),
	fmt_write_string(TestFile35, '%s%sutf8-cent.xml',f(TestPath,Slash)),
        load_xml_structure(file(TestFile35),O35, W35),
        writeln(O35),
	told,
	fmt_write_string(OutFile36, 'actualoutput%sutf8.ok', f(Slash)),
	tell(OutFile36),
	fmt_write_string(TestFile36, '%s%sutf8.xml',f(TestPath,Slash)),
        load_sgml_structure(file(TestFile36),O36, W36),
        writeln(O36),
	told,
	fmt_write_string(OutFile37, 'actualoutput%sutf8string.ok', f(Slash)),
	tell(OutFile37),
        load_xml_structure(string('<utf8><name>Dürst</name><name name="Dürst"/></utf8>'),O37, W37),
        writeln(O37),
	told,
	fmt_write_string(OutFile38, 'actualoutput%stestdoc.ok', f(Slash)),
	tell(OutFile38),
        load_sgml_structure(string('<testdoc id="t7-20020923" resp="MSM"><names>From Española -- a ~@~Xtest~@~Y for you.</names><nums>From Española -- a ~@~Xtest~@~Y for you.</nums><names>From Española -- a ~@~Xtest~@~Y for you.</names><nums>From Española -- a ~@~Xtest~@~Y for you.</nums></testdoc>'),O38, W38),
        writeln(O38),
	told,
	fmt_write_string(OutFile39, 'actualoutput%sw3.ok', f(Slash)),
	tell(OutFile39),
	load_xml_structure(url('http://w3.org'),O39, W39),
        writeln(O39),
	told.

sgmldir(SgmlDir) :-
        xsb_configuration(install_dir, PackDir),
        slash(Slash),
        fmt_write_string(SgmlDir, '%s%sexamples%ssgml%sfiles',
        f(PackDir, Slash, Slash, Slash)).

error_handler( X) :- writeln( X ), true.

